## hardinfo 2.2.16

=== CMakeLists.txt ===
#hardinfo2 supports CMake version 3.0.2->
if(${CMAKE_VERSION} VERSION_GREATER "3.30.99")
    cmake_minimum_required(VERSION 3.10.0)
    cmake_policy(VERSION 3.10.0)
    SET(CMAKE_EXECUTABLE_ENABLE_EXPORTS 1)
else()
    if(${CMAKE_VERSION} VERSION_GREATER "3.26.99")
        cmake_minimum_required(VERSION 3.5.0)
        cmake_policy(VERSION 3.5.0)
	SET(CMAKE_EXECUTABLE_ENABLE_EXPORTS 1)
    else()
        cmake_minimum_required(VERSION 3.0.2)
        cmake_policy(VERSION 3.0.2)
    endif()
endif()
project(hardinfo2)

#Release settings
set(HARDINFO2_VERSION "2.2.16")
set(HARDINFO2_RELEASE_DATE "2026-01-15")
set(HARDINFO2_RELEASE_NOTE_HTML "<p>Release</p><p>\nImprovements\nLots of minor fixes/maintenance/updates/cleanup\nFor details see homepage news.</p>")

#Build settings
option(HARDINFO2_SERVICE "Build with service support" 1)
option(HARDINFO2_GTK3 "Build for GTK3 (0/off for GTK2)" 1)
option(HARDINFO2_LIBSOUP3 "Build for libsoup-3.0 (0/off for libsoup-2.4)" 1)
#Please use QT5 as long as possible to support compare to other distros
option(HARDINFO2_QT6 "EXPERIMENTAL - Build opengl benchmark for QT6" 0)
option(HARDINFO2_QT5 "Build opengl benchmark for QT5" 1)
option(HARDINFO2_QT_MOCQT "Build QTx with moc-qtx" 0)
option(HARDINFO2_VK "Build vulkan benchmark" 1)
option(HARDINFO2_VK_WAYLAND "Build Vulkan with wayland support" 1)
option(HARDINFO2_VK_X11 "Build Vulkan with X11 support" 1)
option(HARDINFO2_NOSSL "Build for very old distro with no https" 0)

#To allow manually setting QT6 only from cmd line
if(HARDINFO2_QT6)
  set(HARDINFO2_QT5 0)
endif()
SET(CMAKE_INSTALL_PREFIX "/usr")
SET(HARDINFO2_SYSTEMV 0)
SET(HARDINFO2_RUNIT 0)
string(SUBSTRING ${HARDINFO2_RELEASE_DATE} 0 4 HARDINFO2_RELEASE_YEAR)
file(READ "${CMAKE_CURRENT_SOURCE_DIR}/tools/org.hardinfo2.hardinfo2.metainfo.xml" METAINFO_CONTENT)
string(REPLACE "VERSION" "${HARDINFO2_VERSION}" METAINFO_CONTENT "${METAINFO_CONTENT}" )
string(REPLACE "RELEASE_DATE" "${HARDINFO2_RELEASE_DATE}" METAINFO_CONTENT "${METAINFO_CONTENT}" )
string(REPLACE "DESCRIPTION" "${HARDINFO2_RELEASE_NOTE_HTML}" METAINFO_CONTENT "${METAINFO_CONTENT}" )

SET(CMAKE_MODULE_PATH  "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
include(GNUInstallDirs)

if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
	set(HARDINFO2_OS "linux")
else()
	message(FATAL_ERROR "Unsupported operating system: ${CMAKE_SYSTEM_NAME}")
endif()

if(${CMAKE_SYSTEM_PROCESSOR} MATCHES "i[3-6]86")
	set(HARDINFO2_ARCH "x86")
elseif(${CMAKE_SYSTEM_PROCESSOR} MATCHES "x86_64")
	set(HARDINFO2_ARCH "x86")
elseif(${CMAKE_SYSTEM_PROCESSOR} MATCHES "(ppc|ppc32|ppc64|ppc64le)")
	set(HARDINFO2_ARCH "ppc")
elseif(${CMAKE_SYSTEM_PROCESSOR} MATCHES "(mips|mips64el)")
	set(HARDINFO2_ARCH "mips")
elseif(${CMAKE_SYSTEM_PROCESSOR} MATCHES "parisc.*")
	set(HARDINFO2_ARCH "parisc")
elseif(${CMAKE_SYSTEM_PROCESSOR} MATCHES "sparc32|sparc64")
	set(HARDINFO2_ARCH "sparc")
elseif(${CMAKE_SYSTEM_PROCESSOR} MATCHES "arm.*")
	set(HARDINFO2_ARCH "arm")
elseif(${CMAKE_SYSTEM_PROCESSOR} MATCHES "aarch64.*")
	set(HARDINFO2_ARCH "arm")
elseif(${CMAKE_SYSTEM_PROCESSOR} MATCHES "ia64")
	set(HARDINFO2_ARCH "ia64")
elseif(${CMAKE_SYSTEM_PROCESSOR} MATCHES "(loongarch64|loong64)")
	set(HARDINFO2_ARCH "loongarch64")
elseif(${CMAKE_SYSTEM_PROCESSOR} MATCHES "alpha")
	set(HARDINFO2_ARCH "alpha")
elseif(${CMAKE_SYSTEM_PROCESSOR} MATCHES "s390.*")
	set(HARDINFO2_ARCH "s390")
elseif(${CMAKE_SYSTEM_PROCESSOR} MATCHES "m68k")
	set(HARDINFO2_ARCH "m68k")
elseif(${CMAKE_SYSTEM_PROCESSOR} MATCHES "sh[3-5]")
	set(HARDINFO2_ARCH "sh")
elseif(${CMAKE_SYSTEM_PROCESSOR} MATCHES "(riscv|riscv32|riscv64)")
	set(HARDINFO2_ARCH "riscv")
elseif(${CMAKE_SYSTEM_PROCESSOR} MATCHES "e2k")
	set(HARDINFO2_ARCH "e2k")
else()
	message(FATAL_ERROR "Unsupported architecture: ${CMAKE_SYSTEM_PROCESSOR}")
endif()

add_definitions(-DLOCALEDIR="${CMAKE_INSTALL_FULL_LOCALEDIR}")
message(STATUS "LOCALEDIR = ${CMAKE_INSTALL_FULL_LOCALEDIR}")

message(STATUS "Building HardInfo2 for architecture: ${HARDINFO2_OS}-${HARDINFO2_ARCH}")

#add_definitions("-std=gnu89")
#add_definitions("-fanalyzer")
add_definitions("-Wall")
add_definitions("-Wextra")
add_definitions("-Wno-missing-field-initializers")
add_definitions("-Wno-ignored-attributes")
add_definitions("-Wno-unused-parameter")
add_definitions("-Wno-missing-braces")
add_definitions("-Wformat")
add_definitions("-Wformat-security")

set(PACKAGE_LIBSOUP2_MINVERSION 2.42)
set(PACKAGE_LIBGLIB2_MINVERSION 2.24)
SET(RPM_REQ "dmidecode, sysbench, udisks2, glx-utils, lm_sensors, xdg-utils, iperf3, fwupd, xrandr, vulkan-tools, gawk")
SET(DEB_REQ "dmidecode, sysbench, udisks2, mesa-utils, lm-sensors, xdg-utils, iperf3, fwupd, x11-xserver-utils, vulkan-tools, gawk")

#########################CPack PACKAGING SETUP###############################
if(EXISTS "/etc/os-release")
  file(STRINGS /etc/os-release distro REGEX "^NAME=")
  file(STRINGS /etc/os-release disversion REGEX "^VERSION_ID=")
  file(STRINGS /etc/os-release disversioncode REGEX "^VERSION_CODENAME=")
else()
  set(distro "Linux")
  set(disversion "99")
  set(disversioncode "Linux")
endif()
set(RPM 0)
set(TGZ 0)
string(REGEX REPLACE "NAME=" "" distro "${distro}")
string(REGEX REPLACE "\"" "" distro "${distro}")
string(REGEX REPLACE "/" "" distro "${distro}")
string(REGEX REPLACE " " "" distro "${distro}")
string(REGEX REPLACE "VERSION_ID=" "" disversion "${disversion}")
string(COMPARE EQUAL "${disversion}" "" result)
if(result)
  #sid/rawhide with no version - use project name
  message("-- Found no distro version - Using codename")
  string(REGEX REPLACE "VERSION_CODENAME=" "" disversion "99_${disversioncode}")
endif()
string(REGEX REPLACE "\"" "" disversion "${disversion}")
string(REGEX REPLACE "/" "" disversion "${disversion}")
string(REGEX REPLACE " " "" disversion "${disversion}")
#RPM Distro's
if(${distro} MATCHES "Alma*" OR ${distro} MATCHES "Rocky*" OR ${distro} MATCHES "Fedora*" OR ${distro} MATCHES "RedHat*" OR ${distro} MATCHES "CentOS*" OR ${distro} MATCHES "Oracle*" OR ${distro} MATCHES "openSUSE*" OR ${distro} MATCHES "SUSE*" OR ${distro} MATCHES "PCLinuxOS*" OR ${distro} MATCHES "Ultramarine*" OR ${distro} MATCHES "Nobara*" OR ${distro} MATCHES "OpenMandriva*")
  #ALT Linux is RPM but too old rpmbuild - use alien until fixed
  # OR ${distro} MATCHES "ALT*" OR ${distro} MATCHES "SimplyLinux"
  #Support for debian edition (eg. pclinuxos)
  if(${distro} MATCHES "Debian*")
    set(RPM 0)
  else()
    set(RPM 1)
  endif()
endif()
#Arch Distro's (tgz)
if(${distro} MATCHES "Arch*" OR ${distro} MATCHES "Endeavour*" OR ${distro} MATCHES "Garuda*" OR ${distro} MATCHES "Reborn*" OR ${distro} MATCHES "SystemRescue*" OR ${distro} MATCHES "Artix*" OR ${distro} MATCHES "Manjaro*")
  set(TGZ 1)
endif()
#Package architecture
if(${RPM})
  set(PACKAGE_DELIMITER "-")
  set(PACKAGE_ARCHITECTURE ".${CMAKE_SYSTEM_PROCESSOR}")
else()
  set(PACKAGE_DELIMITER "_")
  set(PACKAGE_ARCHITECTURE "_${CMAKE_SYSTEM_PROCESSOR}")
  if(${CMAKE_SYSTEM_PROCESSOR} MATCHES "x86_64")
    set(PACKAGE_ARCHITECTURE "_amd64")
  endif()
endif()
set(PACKAGE_DISTRO ${HARDINFO2_VERSION}-${distro}-${disversion}${CPACK_SYSTEM_NAME})
SET(CPACK_PACKAGE_VERSION ${HARDINFO2_VERSION})
#Put it together
string(REPLACE " " "${PACKAGE_DELIMITER}" CPACK_PACKAGE_FILE_NAME "hardinfo2${PACKAGE_DELIMITER}${PACKAGE_DISTRO}${PACKAGE_ARCHITECTURE}")
string(REPLACE " " "${PACKAGE_DELIMITER}" CPACK_SOURCE_PACKAGE_FILE_NAME "hardinfo2${PACKAGE_DELIMITER}${PACKAGE_DISTRO}${PACKAGE_ARCHITECTURE}")
message("-- Found Package Version ${CPACK_PACKAGE_VERSION}")
message("-- Found distro description ${distro}${disversion}")

#flavour output
set(HARDINFO2_OS ${distro})

#fedora ->35
if(${disversion} LESS 35.99)
  if(${distro} MATCHES "Fedora*")
    message("Fedora ->35 - LS24")
    set(HARDINFO2_LIBSOUP3 0)
  endif()
endif()

#centos/redhat/oracle ->9
if(${disversion} LESS 9.99)
  if(${distro} MATCHES "Red*" OR ${distro} MATCHES "CentOS*" OR ${distro} MATCHES "Oracle*" OR ${distro} MATCHES "Alma*" OR ${distro} MATCHES "Rocky*")
    message("Centos/Redhat/oracle/rocky/alma ->9 - LS24")
    set(HARDINFO2_LIBSOUP3 0)
  endif()
endif()

#centos/redhat/oracle/opensuse/suse ->8
if(${disversion} LESS 8.99)
  if(${distro} MATCHES "Red*" OR ${distro} MATCHES "CentOS*" OR ${distro} MATCHES "Oracle*" OR ${distro} MATCHES "openSUSE*" OR ${distro} MATCHES "Alma*" OR ${distro} MATCHES "Rocky*")
    message("Centos/Redhat/oracle/opensuse/suse/rocky/alma ->8 - Old Appstream metainfo VK_WAYLAND=0")
    SET(HARDINFO2_VK_WAYLAND 0)
    string(REPLACE "<url type=\"contact\">https://github.com/hardinfo2/hardinfo2/discussions</url>" "" METAINFO_CONTENT "${METAINFO_CONTENT}" )
  endif()
endif()

#centos/redhat/oracle/alma/rocky 10
#note upgrade to 10.1 for sysbench to be available
if((${disversion} GREATER_EQUAL 10) AND (${disversion} LESS 10.99))
  if(${distro} MATCHES "Red*" OR ${distro} MATCHES "CentOS*" OR ${distro} MATCHES "Oracle*" OR ${distro} MATCHES "Alma*" OR ${distro} MATCHES "Rocky*")
    message("Centos/Redhat/oracle/rocky/alma 10 - Missing xrandr vue to wayland standard")
    SET(RPM_REQ "dmidecode, sysbench, udisks2, glx-utils, lm_sensors, xdg-utils, iperf3, fwupd, vulkan-tools, gawk") #miss xrandr
  endif()
endif()

#centos/redhat/oracle/opensuse/suse 7
if(${disversion} LESS 7.99)
  if((${distro} MATCHES "Red*" OR ${distro} MATCHES "CentOS*" OR ${distro} MATCHES "Oracle*" OR ${distro} MATCHES "openSUSE*" OR ${distro} MATCHES "SUSE*"))
      SET(RPM_REQ "dmidecode, sysbench, udisks2, glx-utils, lm_sensors, xdg-utils, iperf3, fwupd, xrandr, gawk") #miss vulkan-tools
      set(HARDINFO2_VK 0)
  endif()
endif()

#centos/redhat/oracle/opensuse/suse 6
if(${disversion} LESS 6.99)
  if((${distro} MATCHES "Red*" OR ${distro} MATCHES "CentOS*" OR ${distro} MATCHES "Oracle*" OR ${distro} MATCHES "openSUSE*" OR ${distro} MATCHES "SUSE*"))
    message("RPM EL6 - Too old to have run directory - creating at install")
    #create run directory owned by root
    install(DIRECTORY DESTINATION /run)
    message("RPM EL6 - GTK2 - deprecated - support will end at any time")
    set(HARDINFO2_GTK3 0)
    message("RPM EL6 - LS24 - deprecated version 2.34.3 - but ok")
    set(PACKAGE_LIBSOUP2_MINVERSION 2.34.3)
    set(HARDINFO2_SYSTEMV 1)
    message("RPM EL6 - no QT5+VK - Disabling benchmarks")
    set(HARDINFO2_QT5 0)
    set(HARDINFO2_QT6 0)
    set(HARDINFO2_VK 0)
    message("RPM EL6 - NOSSL too old for https")
    set(HARDINFO2_NOSSL 1)
    SET(RPM_REQ "dmidecode, sysbench, glx-utils, lm_sensors, xdg-utils, xrandr, gawk") #miss vulkan-tools, udisks2, fwupd, iperf3
  endif()
endif()

#opensuse
if(${distro} MATCHES "openSUSE*")
  SET(RPM_REQ "dmidecode, sysbench, udisks2, xdg-utils, fwupd, xrandr,vulkan-tools,  Mesa-demo-x, iperf, sensors, gawk")
  #opensuse tumbeweed
  if(${disversion} GREATER 20000101)
  else()
    #opensuse leap 16
    if(${disversion} GREATER 15.99)
       SET(RPM_REQ "dmidecode, sysbench, udisks2, xdg-utils, xrandr,vulkan-tools,  Mesa-demo-x, iperf, sensors, gawk") #Some error for fwupd vs KDE6 dependencies
    endif()
  endif()
endif()


#Fedora 23
if(${distro}${disversion} MATCHES "Fedora23")
    message("FC23 - no QT5+VK - Disabling benchmarks")
    set(HARDINFO2_QT6 0)
    set(HARDINFO2_QT5 0)
    set(HARDINFO2_VK 0)
    message("Fedora 23 - Too Old for HTTPS")
    set(HARDINFO2_NOSSL 1)
    SET(RPM_REQ "dmidecode, sysbench, udisks2, glx-utils, lm_sensors, xdg-utils, iperf3, fwupd, xrandr, gawk") #miss vulkan-tools
    message("Fedora 23 - Too Old for Appstream metainfo")
    string(REPLACE "<component type=\"desktop-application\">" "<component>" METAINFO_CONTENT "${METAINFO_CONTENT}" )
    string(REPLACE "<url type=\"contact\">https://github.com/hardinfo2/hardinfo2/discussions</url>" "" METAINFO_CONTENT "${METAINFO_CONTENT}" )
    string(REPLACE "<url type=\"contact\">https://github.com/hardinfo2/hardinfo2/discussions</url>" "" METAINFO_CONTENT "${METAINFO_CONTENT}" )
