=== debian/changelog ===
hardinfo (2.2.16-1~mx23+1) mx; urgency=medium

  * Rebuild for MX Linux.
  * Add system-group.patch

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 28 Feb 2026 09:31:58 -0800

hardinfo (2.2.16-1~bpo13+1) trixie-backports; urgency=medium

  * Rebuild for trixie-backports.

 -- Boyuan Yang <byang@debian.org>  Wed, 21 Jan 2026 10:14:21 -0500

hardinfo (2.2.16-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Fri, 16 Jan 2026 21:12:20 -0500
