=== debian/control ===
Source: hardinfo
Section: x11
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Boyuan Yang <byang@debian.org>
Uploaders: Simon Quigley <tsimonq2@debian.org>
Build-Depends: debhelper-compat (= 13),
               cmake,
               gettext,
               glslang-tools,
               libdecor-0-dev,
               libglib2.0-dev,
               libgtk-3-dev,
               libjson-glib-dev,
               libqt5opengl5-dev,
               libsoup-3.0-dev,
               libvulkan-dev,
               qtbase5-dev,
               qtbase5-dev-tools,
               zlib1g-dev
Standards-Version: 4.7.3
Homepage: https://github.com/hardinfo2/hardinfo2
Vcs-Git: https://salsa.debian.org/debian/hardinfo.git
Vcs-Browser: https://salsa.debian.org/debian/hardinfo
Description: System Information and Benchmark for Linux Systems
 Hardinfo offers System Information and Benchmark for Linux Systems.
 It is able to obtain information from both hardware and basic software.
 It can benchmark your system and compare to other machines online.

Package: hardinfo
Section: oldlibs
Architecture: all
Depends: hardinfo2, ${misc:Depends}
Description: transitional package
 This is a transitional package. It can safely be removed.

Package: hardinfo2
Architecture: linux-any
Depends: gawk, ${misc:Depends}, ${shlibs:Depends},
            dmidecode,
            fwupd,
#            iperf3,
            lm-sensors,
            mesa-utils,
            sysbench,
            udisks2,
            vulkan-tools,
            x11-xserver-utils,
            xdg-utils
Suggests: iperf3, pciutils
Replaces: hardinfo (<< ${binary:Version}~)
Breaks: hardinfo (<< ${binary:Version}~)
Provides: hardinfo
Description: ${source:Synopsis}
 ${source:Extended-Description}
